/**************************************************
  CodeVisionAVR C Compiler
  (C) 1998-2000 AVRMall, by Park Jung Hyun
  LCD functions
  
  www.avrmall.com 
***************************************************/
  
#include <mega128.h>                                      
#include <delay.h>
#include <mem.h>

void lcd_init(void)
{
	
	delay_ms(15);
	lcd_cmd(0x38); // function_set
	
	delay_ms(5);
	lcd_cmd(0x38); // function_set
	
	delay_us(100);
	lcd_cmd(0x38); // function_set
	delay_us(500);
	
	lcd_cmd(0x38); // function_set
	delay_us(500);
	
	lcd_display_on(); 

	lcd_clear();  
	
	lcd_cmd(0x06);
	lcd_busy();
}

void lcd_data(char data)
{
	lcd_busy();	
	pokeb(0xc000, data);	//writes the byte data to SRAM at 0xc000
        delay_us(100);
}

void lcd_cmd(char cmd)
{
	lcd_busy();	
	pokeb(0x8000, cmd);	//writes the byte data to SRAM at 0x8000
        delay_us(100);
}

char lcd_read(char read)
{	
	read=peekb(0x8000); //reads a byte located in SRAM at 0x8000 	
        delay_us(100);
	return(read);

} 

void lcd_clear(void)
{
	lcd_busy();
        lcd_cmd(0x01);
        delay_us(100);
}

void lcd_display_on(void)
{
	lcd_busy();
	lcd_cmd(0x0c);
}

void lcd_display_off(void)
{
	lcd_busy();
	lcd_cmd(0x08);
}

void lcd_right_shift(void)
{
	lcd_busy();
        lcd_cmd(0x1c);
        delay_us(100);
}

void lcd_left_shift(void)
{
	lcd_busy();
        lcd_cmd(0x18);
        delay_us(100);
}

void lcd_busy(void)
{
	char lcd_status;
	while(lcd_read(lcd_status) & 0x80); 
}

void lcd_ch(char ch)            
{
    	lcd_busy();
    	pokeb(0xc000, ch); 
}

void lcd_str(char *str)         
{
 	unsigned char i = 0;
 	do{
		lcd_ch(str[i]) ;
   	}while(str[++i] != 0x00);	//null=0x00
}

void _lcd_str(flash char *str)
{
	unsigned char i = 0;
 	do{
		lcd_ch(str[i]) ;
   	}while(str[++i] != 0x00);	//null=0x00
}

void Gotoxy(unsigned char x, unsigned char y)	//x-  y |
{
    lcd_busy();
    switch(y)
    {
       case 0: lcd_cmd(0x80+x); break;  
       case 1: lcd_cmd(0xc0+x); break;
       case 2: lcd_cmd(0x94+x); break;
       case 3: lcd_cmd(0xd4+x); break;	
    }
	
}
